{PLIB.INC  (C) Copyright 1983.	software Labs. }
procedure musicinit; extern;			  {initialize Music routines }
procedure musicload(tempo:char;ntimes:integer;const s1,s2,s3:lstring); extern;
			{load the music buffer with music definition lstrings}
procedure musicgo; extern;			 { plays music in background }
function  musicon:boolean; extern;	{returns true if background music on }
procedure musicstop;extern;		     { stops music adn clears buffer }

procedure sound(freq,duration: integer);extern;{ freq Hz. duration/100 second}
function  inport(porti:integer):integer;extern; {returns byte read from porti}
procedure outport(porto,valueo:integer);extern;        {writes value to porto}

function  comminit(portc,baud:integer; parity:char; stopbits,wordlen:integer):
	  word;   extern;	   {initializes an asynchronous port (RS232) }
function  commread(portc:integer):char;extern;		   {reads a character}
function  commwrite(portc:integer; ch: char):boolean; extern;  {false- failed}
function  commstatus( portc: integer ): word; extern;	       {RS232 status }
procedure emuterm(portc:integer; exitkey, duplex: char); extern;
				   { Terminal emulator }

procedure joystick(var ax,ay,bx,by,a1,a2,b1,b2: integer);extern;
		{returns where the joystick is and whether button is pressed }
function  rnd: word; extern;			   { returns a random number }
procedure randomize(seed:word); extern;       {set the seed for random number}

function  numdisk:integer; extern;	   { number of diskette drives (0-4) }
function  numgame:integer; extern;	  { number of game I/O Adapter (0-1) }
function  nummemory:integer; extern;		       { number of k memory; }
function  numpram: integer; extern;	   { planar RAM size (16, 32, 48, 64)}
function  numprinter: integer; extern;		{ number of printers ( 0-3 ) }
function  numcomm: integer; extern;	       { number of RS232 ports (0-2) }

procedure prtinit(portp:integer); extern;		    {portp 0 .. 1}
function  prtstatus( portp: integer ) : word; extern;
procedure prtchr(portp:integer; ch: char); extern;
procedure prtlstring(portp:integer;const line: lstring); extern;

{----------------------------------------------------------------------------}
{ the following routines control an EPSON or IBM printer}
procedure compress(portp:integer); extern;
procedure dblwidth(portp:integer); extern;
procedure formfeed(portp:integer); extern;
procedure prtcrlf(portp:integer); extern;
procedure emphasize(portp:integer); extern;
procedure unempha(portp:integer); extern;
procedure dblstrike(portp:integer); extern;
procedure undblstrike(portp:integer); extern;
procedure regular(portp:integer); extern;
